* Challenge_Find_Variables_with_Missing_labels.SPS.

* Execute next line then run the script.
GET FILE='C:\Program Files\spss\1991 U.S. General Social Survey.sav'.
* run script at this point.



* Read file which was written by script.
DATA LIST FILE='c:\temp\vnames and values.txt' LIST /vnum(F8) vname(A8) val(F8).
XSAVE OUTFILE='c:\temp\list of values.sav'.

* Find first and last values of each variable.
MATCH FILES FILE=* /BY=vnum /FIRST=first /LAST=last.

* write syntax file which will replace all values which have a label by $SYSMIS.
DO IF $CASENUM=1 OR vname<>LAG(vname).
- WRITE OUTFILE='c:\temp\my syntax.sps'
	/'IF ANY(VALUE('vname'),' val.
- ELSE IF NOT last.
- WRITE OUTFILE='c:\temp\my syntax.sps'
	/'  ,'val.
- ELSE.
- WRITE OUTFILE='c:\temp\my syntax.sps'
	/'  ,'val') ' vname'=$SYSMIS.'.
END IF.
EXECUTE.

* get list of variables of interest.
GET FILE='c:\temp\list of values.sav'.
AGGREGATE OUTFILE=*
	/PRESORTED
	/BREAK=vnum
	/vname=FIRST(vname).
* Write syntax which will delete variables we do not need (scale variables with 1 to 3 value labels).
DO IF $CASENUM=1.
- WRITE OUTFILE='c:\temp\keep only good vars.sps'
	/'ADD FILES FILE=* /KEEP='vname.
- ELSE.
- WRITE OUTFILE='c:\temp\keep only good vars.sps'
	/'  'vname.
END IF.
EXECUTE.


GET FILE='C:\Program Files\spss\1991 U.S. General Social Survey.sav'.
INCLUDE 'c:\temp\keep only good vars.sps'

* Next paragraph adds 100 to 0.2% of cases, these values will not have value labels.
* Of course you have to delete this paragraph when you do your job. 
SET SEED=98761542.
DO REPEAT var=ALL.
IF UNIFORM(1)<.002 var=var + 100.
END REPEAT.

* Replace values which have labels by $SYSMIS.
INCLUDE 'c:\temp\my syntax.sps'.

*////////////////.
DEFINE !list (vnames=!CMDEND)
!LET !listv=!HEAD(!vnames)
!LET !t=!TAIL(!vnames)
!DO !v !IN (!t) 
  !LET !listv=!CONCAT(!listv,' + ', !v) 
!DOEND

CTABLES
  /VLABELS VARIABLES=ALL DISPLAY=DEFAULT
  /TABLE (!listv) [COUNT F40.0]
  /CATEGORIES VARIABLES=ALL ORDER=A KEY=VALUE EMPTY=EXCLUDE MISSING=EXCLUDE
  /TITLES TITLE="List of values without value labels".

!LET !listv=!HEAD(!vnames)
!DO !v !IN (!t) 
  !LET !listv=!CONCAT(!listv,' , ', !v) 
!DOEND

COMPUTE flag=NVALID(!listv).
COMPUTE casen=$CASENUM.
EXECUTE.
SELECT IF flag>0.
SAVE OUTFILE='c:\temp\cases without labels.sav'.

!ENDDEFINE.
*////////////////.

SET MPRINT=yes.
!list vnames=childs happy helpoth hlth1 hlth2 hlth3 hlth4 hlth5 hlth6 hlth7 hlth8 hlth9 life obey occcat80 popular tax thnkself usintl
  work1 work2 work3 work4 work5 work6 work7 work8 work9 workhard. 

