* macros_change_format_of_many_variables.sps.

*/////////////////////.
DEFINE !conver (type=!TOKENS(1)
		/cformat=!TOKENS(1)
		/nformat=!TOKENS(1)
		/vnames=!CMDEND)
/* where. 
* type    = ss (string to string) ns (numeric to string) or sn.
* cformat = the conversion format (required when type=sn or ns).
* nformat = the new format (required).
* vnames  = the names of the variables to change (required).

!DO !vname !IN (!vnames)
!IF (!type='ss') !THEN
STRING temp1234(!nformat).
COMPUTE temp1234=!vname.
!IFEND

!IF (!type='ns') !THEN
STRING temp1234(!nformat).
COMPUTE temp1234=LTRIM(STRING(!vname,!cformat)).
!IFEND

!IF (!type='sn') !THEN
NUMERIC temp1234(!nformat). 
COMPUTE temp1234=NUMBER(!vname,!cformat).
!IFEND

* Next command requires at least version 11.5.
APPLY DICTIONARY FROM=* /SOURCE VARIABLES=!vname /TARGET VARIABLES=temp1234.
MATCH FILES FILE=* /DROP=!vname.
RENAME VARIABLE (temp1234=!vname).
!DOEND
!ENDDEFINE.
*//// conver ////////.


* Testing the macro.
DATA LIST LIST /var1(A12) vnum2(A8) varx(A12) vary(A8).
BEGIN DATA
'1,235.23'	1254.13	'1,762.00'	6532.20 
'5,3261.32'	 128.09	'3,265.85'	2591.99
END DATA.
VARIABLE LABEL var1 'Account value'.
SUMMARIZE /TABLES=var1 varx vary vnum2 /FORMAT=LIST /CELLS=NONE.

SET MPRINT=yes.
!conver type=sn  cformat=f8.2      nformat=comma8.0   vnames=vnum2 vary.
!conver type=sn  cformat=comma8.2  nformat=dollar8.2  vnames=var1 varx.
SET MPRINT=no.
SUMMARIZE /TABLES=var1 varx vary vnum2 /FORMAT=LIST /CELLS=NONE.
