*macros_new_variables_containing_bounds_of_CI_for_mean.sps.

DEFINE !AddCInt (vname=!TOKENS(1) /conf=!TOKENS(1) /fname=!TOKENS(1))
GET FILE=!fname.
SELECT IF NOT MISSING(!vname).
/* next command is only for checking purposes */
EXAMINE
  VARIABLES=!vname
  /COMPARE GROUP /PLOT=NONE
  /STATISTICS DESCRIPTIVES
  /CINTERVAL !conf
  /MISSING LISTWISE
  /NOTOTAL.
COMPUTE nobreak=1.
AGGREGATE OUTFILE=*
  /BREAK=nobreak
  /N=n /sd_var=SD(!vname) /mean_var=MEAN(!vname).
COMPUTE se_mean=sd_var/SQRT(n).
/* Compute lower and upper CI limit. */
COMPUTE lowCI=mean_var - se_mean * IDF.T(1-(100-!conf)/200,n-1).
COMPUTE upCI=mean_var + se_mean * IDF.T(1-(100-!conf)/200,n-1).
VARIABLE LABELS lowCI !QUOTE(!CONCAT("Lower ",!conf,"% CI for mean ",!vname)).
VARIABLE LABELS upCI !QUOTE(!CONCAT("Upper ",!conf,"% CI for mean ",!vname)).
SAVE OUTFILE='c:\temp\temp.sav' /KEEP=nobreak lowCI upCI.
GET FILE=!fname.
COMPUTE nobreak=1.
MATCH FILES FILE=*
  /TABLE='c:\temp\temp.sav' 
  /BY=nobreak
  /DROP=nobreak.
EXECUTE.
!ENDDEFINE.

** Example (95% CI for a large sample).
!addCInt vname=salary conf=95 
  fname='c:\examples\data\Employee data.sav'.

** Example (90% CI for a small sample).
GET FILE='c:\examples\data\Employee data.sav'.
N OF CASES 15.
SAVE OUTFILE='c:\temp\eee data.sav'.
!addCInt vname=salbegin conf=90 
  fname='c:\temp\eee data.sav'.
