* macros_random_samples_fixed_sample_size.sps.

SET MPRINT=no.

*//////////////////.
DEFINE !sample(file !TOKENS(1)
		/myvar !TOKENS(1) 
		/mystat=!TOKENS(1)
		/size !TOKENS(1)
		/nbsampl !CMDEND)
/* myvar   = the variable of interest     */
/* mystat  = the statistic of interest    */
/* nbsampl = number of samples            */
/* size    = the size of each sample      */

!LET !first='1'
!DO !ns !IN (!nbsampl)
!DO !count = 1 !TO !ns.

GET FILE=!file.

COMPUTE draw=uniform(1).
SORT CASES BY draw.
N OF CASES !size.

COMPUTE samplenb=!count. 
COMPUTE ns=!ns.

AGGREGATE OUTFILE=*
  /PRESORTED
  /BREAK=samplenb
  /!myvar = !mystat(!myvar) /ns=FIRST(ns).

!IF (!first !NE '1') !THEN
ADD FILES /FILE=*  /FILE='c:\temp\sample.sav'.
!IFEND
SAVE OUTFILE='c:\temp\sample.sav'.
!LET !first='0'

!DOEND. 
!DOEND. 

FORMATS ns (F8).
VARIABLE LABELS ns !QUOTE(!CONCAT('Number of Samples of size ',!size))
	/!myvar !QUOTE(!CONCAT(!mystat," ",!myvar)).
EXAMINE VARIABLES=salary BY ns 
  /PLOT=BOXPLOT/STATISTICS=NONE/NOTOTAL
  /MISSING=REPORT.

!ENDDEFINE.
*//// sample ///////.

* Call macro (parameters are number of samples (here 5 10 25 35 50) 
	and size of sample (here 10). 
* Thus we want 5 samples of size 10.
* 	10 samples of size 10, etc.

SET MPRINT=yes.
!sample file='c:\Program Files\SPSS\employee data.sav'
   myvar=salary mystat=mean size=10 nbsampl=5 10 25 35 50.

